﻿using System.Collections.Generic;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.DotProlog.Execution;
using OpcLabs.DotProlog.Terms;
using OpcLabs.DotProlog.Test;

namespace DotPrologTest.Execution
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class Conjunction_2_Test : ExecutionTest
    {
        #region Test Methods
        // ReSharper disable InconsistentNaming

        [TestMethod]
        public void Test_7_8_5_4_Examples_1()
        {
            using (IEngine engine = new Engine())
            {
                Test(engine, Parse("','(X=1, var(X)). "), Failure(), "Expected failure.");
            }
        }

        [TestMethod]
        public void Test_7_8_5_4_Examples_2()
        {
            using (IEngine engine = new Engine())
            {
                Term goal = Parse("','(var(X), X=1). ", out IDictionary<string, Variable> variableNameDictionary);
                Term expectedX = new PInteger(1);
                var expected = new VariableDictionary {{ variableNameDictionary["X"], expectedX }};
                Test(engine, goal, Success(expected));
                //FrontEnd.PrintResults(engine.Call(goal), variableNameDictionary);
            }
        }

        [TestMethod]
        public void Test_7_8_5_4_Examples_3()
        {
            using (IEngine engine = new Engine())
            {
                Term goal = Parse("','(X=true, call(X)). ", out IDictionary<string, Variable> variableNameDictionary);
                Term expectedX = Atom.Add("true");
                var expected = new VariableDictionary { { variableNameDictionary["X"], expectedX } };
                Test(engine, goal, Success(expected));
                //FrontEnd.PrintResults(engine.Call(goal), variableNameDictionary);
            }
        }

        // ReSharper restore InconsistentNaming
        #endregion
    }
}
