﻿using JetBrains.Annotations;
using OpcLabs.BaseLib.Collections.Specialized;
using OpcLabs.EasyOpc.UA.Engine;

namespace OpcLabs.EasyOpcFactory.UA.Engine
{
    static public class UACertificateAcceptancePolicyInstances
    {
        [NotNull]
        static public UACertificateAcceptancePolicy Instance1 => new UACertificateAcceptancePolicy
        {
            AcceptAnyCertificate = true,
            TrustedEndpointUrlStrings = new StringCollection {"url1", "url2"},
        };

        [NotNull]
        static public UACertificateAcceptancePolicy Instance2 => new UACertificateAcceptancePolicy
        {
            AcceptAnyCertificate = true,
            AllowSha1SignedCertificates = false,
            AllowUserAcceptCertificate = false,
            MinimumCertificateKeySize = 555,
            TrustedEndpointUrlStrings = new StringCollection { "url1", "url2" },
        };
    }
}
