﻿using System;
using System.IO;
using System.Runtime.InteropServices;
using JetBrains.Annotations;
using OpcLabs.BaseLib;
using OpcLabs.BaseLib.Communication;
using OpcLabs.EasyOpc.UA.OperationModel;

namespace OpcLabs.EasyOpcFactory.UA.OperationModel
{
    static public class EasyUAServerConditionChangedEventArgsInstances
    {
        [NotNull]
        static public EasyUAServerConditionChangedEventArgs Instance0 => new EasyUAServerConditionChangedEventArgs();

        [NotNull]
        static public EasyUAServerConditionChangedEventArgs Instance1 => new EasyUAServerConditionChangedEventArgs
        {
            EndpointDescriptor = UAEndpointDescriptorInstances.Instance1,
            ConnectionState = ConnectionState.Connected
        };

        [System.Diagnostics.CodeAnalysis.SuppressMessage("Microsoft.Design", "CA1065:DoNotRaiseExceptionsInUnexpectedLocations")]
        [NotNull]
        static public EasyUAServerConditionChangedEventArgs Instance2 => new EasyUAServerConditionChangedEventArgs
        {
            EndpointDescriptor = UAEndpointDescriptorInstances.Instance1,
            ErrorId = "-2",
            Exception = new COMException("TestMessage2"),
            Diagnostics = { new ApplicationException("Diagnostics1", new IOException("Diagnostics2")) }
        };
    }
}
