﻿
using System;
using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.BaseLib.Collections.ObjectModel.Extensions;
using OpcLabs.EasyOpc.AlarmsAndEvents;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpcFactory.AlarmsAndEvents;
using OpcLabs.EasyOpcTest.AlarmsAndEvents.AddressSpace;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest.AlarmsAndEvents
{
    public partial class AEConditionStateTest
    {
        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest0()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("BinarySerialization")]
        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestMethod]
        public void BinarySerializationTest1()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget1());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest0()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget0());
        }

        [TestCategory("OpcAlarmsAndEvents")]
        [TestCategory("OpcClassic")]
        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest1()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget1());
        }

        [NotNull]
        public AEConditionState CreateSerializationTarget0()
        {
            return new AEConditionState();
        }

        [NotNull]
        public AEConditionState CreateSerializationTarget1()
        {
            var conditionState = new AEConditionState
            {
                AcknowledgeTime = DateTime.Now.ToUniversalTime(),
                Acknowledged = true,
                AcknowledgerId = "TestAcknowledgerId",
                Active = false,
                ActiveSubcondition = _subconditionElementTest.CreateSerializationTarget1(),
                ActiveTime = DateTime.MaxValue,
                AttributeValues = AEAttributeValueDictionaryInstances.Instance2,
                Comment = "TestComment",
                Enabled = true,
                InactiveTime = DateTime.MinValue,
                Quality = DAQualities.UncertainNonspecific,
                SubconditionActiveTime = DateTime.Now.ToUniversalTime(),
            };

            conditionState.SubconditionElements.AddNew(_subconditionElementTest.CreateSerializationTarget1());
            conditionState.SubconditionElements.AddNew(_subconditionElementTest.CreateSerializationTarget2());
            conditionState.SubconditionElements.AddNew(_subconditionElementTest.CreateSerializationTarget3());

            return conditionState;
        }

        [NotNull]
        private readonly AESubconditionElementTest _subconditionElementTest = new AESubconditionElementTest();
    }
}
