﻿using JetBrains.Annotations;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.Engine;
using OpcLabs.UnitTestLib;

namespace OpcLabs.EasyOpcTest
{
    [TestClass]
    public class EasyClientParametersTest
    {
        [TestCategory("BinarySerialization")]
        [TestMethod]
        public void BinarySerializationTest()
        {
            Tests.BinarySerializationTest(CreateSerializationTarget());
        }

        [TestCategory("XmlSerialization")]
        [TestMethod]
        public void XmlSerializationTest()
        {
            Tests.XmlSerializationTest(CreateSerializationTarget());
        }

        [NotNull]
        private EasyClientParameters CreateSerializationTarget()
        {
            return new EasyClientParameters
            {
                ClientReconnectDelay = 1,
                ExecutionContext = 2,
                ServerFailedReconnectDelay = 3,
                ServerShutdownReconnectDelay = 4,
                ServerStatusCheckPeriod = 5,
                TurnOffActivationSecurity = true
            };
        }
    }
}
