﻿using System.Collections.Generic;
using System.Linq;
using Microsoft.VisualStudio.TestTools.UnitTesting;
using OpcLabs.EasyOpc.UA;

namespace OpcLabs.OpcInteroperabilityTest.UA.Servers
{
    [TestClass]
    // ReSharper disable once InconsistentNaming
    public class Yokogawa_OpafDemoServer_Test : UAInteroperabilityWorkshopTest
    {
        public override IEnumerable<UANodeDescriptor> DynamicNodes => new UANodeDescriptor[]
        {
            "nsu=http://us.yokogawa.com/ykgw_opas/ ;ns=4;s=Node1.OPAS_Signals.Channel01",
            "nsu=http://us.yokogawa.com/ykgw_opas/ ;ns=4;s=Node1.OPAS_Signals.Channel02",
        };

        public override IEnumerable<UAEndpointDescriptor> EndpointDescriptors => new UAEndpointDescriptor[] { "opc.tcp://192.168.1.9:48010" };

        public override string Password => "yokogawa1";

        public override IEnumerable<string> ServerNotSupportedTests => base.ServerNotSupportedTests.Concat(new[]
        {
            nameof(Group001_Session_Test02_CreateSession_UaTcp_Basic128Rsa15),  // no such endpoints
            nameof(Group001_Session_Test09_CreateSession_Https_None),   // probably not supported
            nameof(Group001_Session_Test10_ActivateSession_X509Certificate),    // no instructions given
            nameof(Group008_Eventing_Test01_Subscribe_Server),
            nameof(Group008_Eventing_Test04_EventNodes_Browse),
            nameof(Group011_AlarmCondition_Test01_Browse_Types),
            nameof(Group013_Discovery_Test03_FindServers_LDS_ServerPresence),   // no LDS appears to be running

            //nameof(Group102_Session2_Test01_CreateSession_UaTcp_Basic256),
            //nameof(Group102_Session2_Test02_CreateSession_UaTcp_Basic256Sha256),
            //nameof(Group102_Session2_Test03_CreateSession_Https_Basic256Sha256)
        });

        public override IEnumerable<UANodeDescriptor> StaticNodes => new UANodeDescriptor[] { "nsu=http://us.yokogawa.com/ykgw_opas/ ;ns=4;s=Node1.NodeStatus" };

        public override string UserName => "yokogawa";
    }
}
